////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// F A R M     -  Flair advanced rendering module
//
// Copyright European Organization for Nuclear Research( CERN )
// All rights reserved
//
// Authors: Christian.Theis@cern.ch
//			    Vasilis.Vlachoudis@cern.ch
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef BXDF_FRESNEL_BLEND_EX_H
#define BXDF_FRESNEL_BLEND_EX_H

#include "bxdfbase.h"
#include "bxdfmicrofacet.h"
#include "bxdffresnelblend.h"

class CBxDFFresnelBlend;
class CMicrofacetDistribution;

class CBxDFFresnelBlendEx : public CBxDFFresnelBlend
{
public:
  CBxDFFresnelBlendEx( CMicrofacetDistribution* pDist);
  virtual ~CBxDFFresnelBlendEx(void);

  // Sample_f samples an incoming ray matching to the outgoing ray + its Pdf. Furthermore it evaluates the
  // BxDF according to In & Out and returns the color. This is used for reflection, refraction etc. which will
  // continue recursively.
  double Sample_f( const Ray& Out, Ray& In, float& Pdf, const Vector& Normal, const Material& RenderMat, Random& Sampler, BxDFType Type, const Color& LightColor = Color( 1.0, 1.0, 1.0 ), double Power = 1.0, float Shade = 1.0 );
};


#endif
// vim:ts=2
