/*
 * Copyright European Organization for Nuclear Research (CERN)
 * All rights reserved
 *
 * Author:	Vasilis.Vlachoudis@cern.ch
 * Date:	08-Aug-2012
 */

#ifndef __GEOMETRY_STL_H
#define __GEOMETRY_STL_H

#include "tool/stream.h"

class Mesh;

/**
 * STL I/O helper class
 */
class STL : public Stream {
public:
	STL() : Stream() {}
	STL(const char* name, Stream::IO io=Stream::IO::Read, bool bin=false)
		: Stream(name, io, bin) {}
	virtual ~STL() {close();}

	bool	read(const char *name, Mesh& mesh);
//	bool	write(const char *name, Mesh& mesh);

#if 0
	/** prepare a valid DXF header */
	void writeHeader();
	/** prepare a valid DXF footer */
	void writeFooter();

	/** write a mesh and check if header is needed
	 * @param mesh mesh to be written
	 * @param color color code to use
	 * @param name override name to use
	 */
	virtual void write(Mesh& mesh, int color=0, const char *name=NULL);

private:
	/** write a vector in DXF format */
	void writeVector(const double x, const double y, const double z);
	void writeVector(const Vector& v)	{ writeVector(v.x, v.y, v.z); }
#endif

private:
	bool	_readAscii(Mesh& mesh);
	bool	_readBinary(Mesh& mesh);
}; // STL

#endif
