/*
 * Copyright European Organization for Nuclear Research (CERN)
 * All rights reserved
 *
 * Author:	Vasilis.Vlachoudis@cern.ch
 * Date:	31-Mar-2010
 */

#include "os.h"
#include "format.h"

#define FLT_SMALL	1.0E-30

/** formating routine
 * @param s	stream to print on
 * @param a	multiplier factor
 * @param suffix	suffix to be multiplied
 */
std::ostream& fmt(std::ostream& s, const double a, const char *suffix)
{
	if (a < 0.0) {
		if (Eq(a,-1.0,FLT_SMALL)) {
			if (suffix)
				s << "-" << suffix;
			else
				s << "-1";
		} else {
			s << a;
			if (suffix)
				s << "*" << suffix;
		}
	} else
	if (a > 0.0) {
		if (Eq(a,1.0,FLT_SMALL)) {
			if (suffix)
				s << "+" << suffix;
			else
				s << "+1";
		} else {
			s << "+" << a;
			if (suffix)
				s << "*" << suffix;
		}
	}
	return s;
} // fmt
